//+------------------------------------------------------------------+
//|                                                     Y(SmCCI).mq4 |
//|                                                         777 |
//|                                                mns777.ru@mail.ru |
//+------------------------------------------------------------------+
#property copyright "777"
#property link      "mns777.ru@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Gold
#property indicator_color2 Blue
//----  
#property  indicator_width1  2
#property  indicator_width2  2
//----    
#property indicator_level1  0.0
#property indicator_level2  -100
#property indicator_level3  100
#property indicator_levelcolor LightSlateGray
#property indicator_levelstyle 2
//---- input parameters
extern int       t3_period=2; // 
extern int       per=336; //  CCI
extern double    b=0.7;
extern int       x_prd=0;
extern int       ppor=100;
extern int       mpor=-100;
extern int       MessageType=0;
extern string    MessageSound="Alert2.wav";
/*
:
- MessageType -   
    0 -   ( )
    1 -   
    2 -  
    3 -   +  
- MessageSound -     (2  4)
*/
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4, n, w1, w2, b2, b3;
double dpo, t3, shift, cci, trig, message, extrem_p, extrem_m;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
string PeroidToStr(int period)
{
   string ret;
   switch(period)
         {
            case 1:
               ret="M1";
               break;
            case 5:
               ret="M5";
               break;
            case 15:
               ret="M15";
	            break;
            case 30:
               ret="M30";
	            break;
            case 60:
               ret="H1";
	            break;
            case 240:
               ret="H4";
	            break;
            case 1440:
               ret="D1";
	            break;
            case 10080:
               ret="W1";
	            break;
            case 43200:
               ret="MN1";
	            break;
        }
   return(ret);
}
//------------------------------------------------------------------------------------------
void AlertExt(int lMessageType, string sOrderType)
{
   switch(lMessageType)
         {
            case 1:
               Alert("SmCCI: ", sOrderType," ", Symbol(),", ",PeroidToStr(Period()));
               break;
            case 2:
               PlaySound(MessageSound);
               break;
            case 3:
               Alert("SmCCI: ", sOrderType," ", Symbol(),", ",PeroidToStr(Period()));
               PlaySound(MessageSound);
	            break;
        }   
   return;
}
//------------------------------------------------------------------------------------------
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   b2=b*b;
   b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);
   n=t3_period;

   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;

   for(int i=Bars-1; i>=0; i--)
   {
      cci=iCCI(NULL,0,per,PRICE_TYPICAL,i);
      dpo=cci;
      e1 = w1*dpo + w2*e1;
      e2 = w1*e1 + w2*e2;
      e3 = w1*e2 + w2*e3;
      e4 = w1*e3 + w2*e4;
      e5 = w1*e4 + w2*e5;
      e6 = w1*e5 + w2*e6;

      t3 = c1*e6 + c2*e5 + c3*e4 + c4*e3;

      if (t3==0) t3=0.0001;
      if (t3>0) trig=ppor;
      if (t3<0) trig=mpor;
      
      ExtMapBuffer1[i]=t3;
      ExtMapBuffer2[i]=trig;
   }
//---------------------------- Messages ------------------------------------   
   if (trig!=message)
      {
         string OType;
         if (trig>0) {OType="BUY";}
         if (trig<0) {OType="SELL";}
         AlertExt(MessageType, OType);
         message=trig;
         extrem_p=1;
         extrem_m=-1;
      }
   if (trig<MathRound(t3) && ppor==trig) {extrem_p=0;}      
   if (trig>=MathRound(t3) && ppor==trig && extrem_p==0) 
      {
         AlertExt(MessageType, "Y(SmCCI)/0 Down ");
         extrem_p=1;
      }
   if (trig>MathRound(t3) && mpor==trig) {extrem_m=0;}   
   if (trig<=MathRound(t3) && mpor==trig && extrem_m==0) 
      {
         AlertExt(MessageType, "Y(SmCCI)/0 Up ");
         extrem_m=-1;
      }
//--------------------------------------------------------------------------   
   return(0);
  }
//+------------------------------------------------------------------+